/*  putcwd.c
    set environmental variable xxx to the current working directory via
    	putcwd xxx
    sets DOS errorlevel to 1 if unsuccessful
    compile with turbo C 1.0 as:  tcc -ml -G -Z putcwd.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <dir.h>

#define lerror( str )  	{  fputs( str, stderr ); _exit(1);  }

main( int argc, char * argv[], char * envp[] )
{
	static char cwd[256];    /* hold env. string for current working dir */
	register char far * env_prim;  /* point to primary environment       */
	register unsigned seg = 0x5f;  /* starting seg for search for envir. */
	register char *env_curr;   /* point to char in current environment   */
	register int i = 0;        /* index to item in current environment   */

	
	if ( argc != 2 )
		lerror( "usage: putcwd env_var\n" );
	strcat( strcpy( cwd, strupr( argv[1] )), "=" );    /* allow 24 chars */
	if ( getcwd( cwd + strlen(cwd), 230 ) == NULL )    /* for var, 230   */
		lerror( "putcwd: can't get directory\n" ); /* for dir name   */
	if ( putenv( cwd ) != 0 ) 
		lerror( "putcwd: assignment failed\n" );

	/* the var is set in the CURRENT environment. must find the PRIMARY */
	do {
		env_prim = (char far * ) MK_FP( ++seg, 0x0 );
		while ( *env_prim != *envp[0] ) {
		    env_prim = MK_FP( ++seg, 0x0 );
		    if ( _psp <= seg )
			lerror( "putcwd: primary environment not found\n" );
		}
	} while ( strcmp( env_prim, envp[0] ) != 0 );

	/* now overwrite the primary environ. with the current environ. */
	/* env_prim points at char of environment being overwritten     */	
	while ( ( env_curr = environ[i++] ) != NULL )
		while ( (*env_prim++ = *env_curr++) != '\0' )
			;
	*env_prim = '\0';
	_exit(0);
}
